/*
 *  Sun Feb  5 20:53:24 EET 2006
 *
 *  MDR-150 RVALVE/etc amateur radio application.
 *
 *  Verify sizeof(cfg) versus stack slack.
 *  3 * sizeof(cfg) is allocated from stack in permanent().
 *
 *  No changes here, appending more cfg.variables is fine.
 *  Ei muutoksia, vain muuttujien lisyst cfg:n loppuun.
 *  Inga vxlingar hr, mer p sluten av cfg r bra.
 *  Nicht ndem. Hinzufgen 'cfg' ist gut.
 *
 *  Refer to variables through cfg.whatnot, nothing fancy.
 *  Edit them through cfgparm array(s).
 *  Before using, if config_size tells it was written by
 *  older software, zero out the missing part and and update
 *  config_size. No rush to save it.
 *
 *  BOOL and TAB are byte variables.
 *  shorts and longs must be word-aligned.
 */

#define CFG_MAGIC_1 0x7A800D01
#define CFG_MAGIC_2 0x7A800D02

/* keep in sync with tab_personality[] */
enum {
	PERSONALITY_VOICE,
	PERSONALITY_TRACKER,
	PERSONALITY_KISS,
	PERSONALITY_PEATER,
	PERSONALITY_SCANNER,
};

/* keep in sync with tab_gps[] XXX this asks for some machinations */
enum  {
	GPS_GENERIC,
	GPS_GARMIN,
	GPS_MAGELLAN,
	GPS_AISIN,
	GPS_SIRF,
	GPS_TRIPMATE,
	GPS_EARTHMATE,
	GPS_ZODIAC,
	GPS_SEATALK,
	GPS_ONCORE,
	GPS_TSIP,
};

/* this never changes, just grows. try to keep short-aligned for fun */

struct channel {
	dword freq;
	dword tx_freq;
	byte  pad[8];       /* this is all you get to expand into */
};

struct hotspot {
	long lat, lon;
	word radius;
	word hyst;
	dword pad[1];
};

extern
struct cfg {
	word  config_size;
	dword cfg_magic_1;

	dword freq;            /* kHz */
	dword tx_freq;         /* kHz, usually 0 = simplex */
	dword rx_if_offset;    /* kHz, subtracted */
	word  squelch;         /* rssi level */
	word  rssi_1led;
	word  rssi_2led;
	word  rssi_3led;

	byte  tx_power;        /* 0 ... 3 meaning 5W ... 50mW */
	byte  personality;
	byte  use_busy;        /* instead of rssi */
	byte  persistence;

	byte  mycall[10];      /* OHnABC-15 regular C-string */
	word  cfg_version;     /* from last PERM. old byte mycall_oopsie[2]; */

	word  slottime;

	word  ttybaud;         /* 0 is 19200 (set by loader, not us) */

	word  squelch_delay;   /* squelch opening delay */
	word  squelch_tail;    /* squelch closing delay */
	word  squelch_bilevel; /* rssi level for snappy squelch */

	byte  myalias[10];     /* OHnABC-15 regular C-string */
	byte  myalias_oopsie[2];

	word  pll_delay;
	word  pwr_delay;

	byte  autobeep;        /* automatic 1750Hz if squelched and duplex */
	byte  autoscan;

	struct channel channel[25]; /* not visible in cfg_parameters[] */

	word  txlimit;
	word  ttylines;

	byte  rfpasswd[16];        /* C-string */

	word  track_distance;
	word  track_interval;
	byte  digipath[10 * 8];    /* C-string */

	byte  aprs_dst[10];        /* OHnABC-15 regular C-string */
	byte  aprs_dst_OOPSIE[2];
	word  mysymbol;            /* direct code */

	byte  myalias2[10];        /* OHnABC-15 regular C-string */

	byte  mydomain[10];        /* OHnABC-15 regular C-string */
	byte  mydomain_oopsie[2];

	byte  gps;
	byte  waypoints;

	byte  use_mic_e;        /* instead of ascii APRS format */
	byte  mic_e_msg;
	byte  mic_e_ssid;

	byte  ptt_packet;
	byte  ptt_origin;

	word  scan_tail;       /* scanner linger delay, sec */
	word  idle_time;       /* delay to scanner autostart, sec */

	byte  :8;
	byte  app_port;

	byte  :8;

	word  data_delay;

	byte  gps_lat[sizeof("06103.52,N")];
	byte  gps_lon[sizeof("02806.21,E")];

	byte  waypoint_tidy[20];

	byte  profile_tag[16];  /* XXX this is handled little bit special */

	word  track_limiter;
	word  track_turnslope;

	word  kiss_trick;

	word  :16;

	word  ctcss;

	/* sizeof(cfg) == 696 at this point */

	byte  myname[10];
	byte  mytype;

	byte  use_compression;   /* if ascii APRS format */

	byte  target_type;
	byte  target_name[10];
	byte  target_symbol_RETIRED_[6]; /* was 12, carved to m_e_t[] below */

	byte  mic_e_telemetry[6];

	bool  target_comment;

	byte  altnet[10];

	word  waypoint_area;

	word  long_area;
	word  long_time;
	byte  longpath[10 * 8];    /* C-string */

	word  track_highg;
	word  track_lowg;

	bool  use_softdcd;

	byte  tracker_digi;
	word  digi_area;

	/* sizeof(cfg) == 834 at this point */

	word  relay_viscosity;

	word  lobatt;

	byte  :8;
	bool  faith_in_pll;

	word  anemoscale;

	bool  do_onewire_RETIRED;
	byte  telemetry_bytes_RETIRED_[7];

	word  battscale;

	byte  :8;

	byte  short_comment[9];
	byte  long_comment[36];

	bool  send_altitude;

	/* 902 and counting */

	byte  telemetry_format[5 + 8 + 7];

	word  radio_range;

			/* 924 and counting */

	dword cfg_magic_2;

			/* 928 and counting */

	word  target_symbol;             /* direct code */

	byte  nmea_regen;
	byte  lcd;
	byte  manipulator;

	byte  bullgroups[32];

	byte  chatboard;

	bool  tx_lockout;

	byte  rn3_function;

	word  vaneoffset;
	bool  wx_dump;

	/* sizeof(cfg) == 972 at this point */

	word  dupe_age;
	byte  wide_is_trace;   /* off, on or never */
	bool  bootflag;        /* XXX this is handled specially */

	byte  event_packet[80];

	word  cell_area;
	bool  dx_watch;
	bool  channel_watch;

	/* sizeof(cfg) == 1060 at this point */

	byte  term_type;

	byte  telemetry_parm[64];
	byte  telemetry_unit[64];
	byte  telemetry_eqns[64];
	byte  telemetry_bits[32];

	/* sizeof(cfg) == 1286 at this point */

	word  maxdigi;

	byte  contact[10];
	byte  data_extension[8];

	/* sizeof(cfg) == 1298 at this point */

	word  track_vertspeed;
	byte  lcd_size;

	byte  sensors;
	byte  d9_function;
	byte  :8;

	word  rainscale;

	struct hotspot hotspots[10]; /* not visible in cfg_parameters[] */

	byte  auth_key[33];
	byte  :8;

	byte  goodfellas[(6 + 1) * 5]; /* "OHnABC OHnDEF", no ssid, max 5 calls */

	/* sizeof(cfg) == 1544 at this point */

	/* always add to the line above this comment. */
} cfg;

#if INTEREST_IN_CFG > 0

/* ordering etc can change at will below */

enum type {
	CFG_NONE,
	CFG_BOOL, CFG_BYTE, CFG_WORD, CFG_LONG, CFG_STR,
	CFG_TAB, CFG_FREQ, CFG_APRSYM, CFG_CALLSIGN
};

struct cfgparm {
	byte type;
	byte group;
	char *name;
	void *address;
	word size;
	word defval;
	byte **optlist;     /* optlist/defval could be an union */
	char *descr;        /* lives in .rodata --- lotsa contortions */
};

#if INTEREST_IN_CFG > 1

/* prhelp.c creates help.s and help.h --- contortive */

#if INTEREST_IN_CFG > 2
#define PARM_DESCR(nam,txt) txt
#else
#define PARM_DESCR(nam,txt) descr_ ## nam
#include "help.h"
#endif

#define MISC_CFG(typ, nam, def, descr, tab) { typ, GROUP, \
	#nam, &cfg.nam, sizeof(cfg.nam), def, tab, PARM_DESCR(nam,descr) }

#define MISC_TAB(nam, tab, descr)    MISC_CFG(CFG_TAB,  nam,   0, descr, tab)

#define MISC_STR(nam, def, descr)    MISC_CFG(CFG_STR,  nam, def, descr, NULL)
#define MISC_BOOL(nam, def, descr)   MISC_CFG(CFG_BOOL, nam, def, descr, NULL)
#define MISC_BYTE(nam, def, descr)   MISC_CFG(CFG_BYTE, nam, def, descr, NULL)
#define MISC_WORD(nam, def, descr)   MISC_CFG(CFG_WORD, nam, def, descr, NULL)
#define MISC_LONG(nam, def, descr)   MISC_CFG(CFG_LONG, nam, def, descr, NULL)
#define MISC_FREQ(nam, def, descr)   MISC_CFG(CFG_FREQ, nam, def, descr, NULL)

#define CALL_SIGN(nam, def, descr)   MISC_CFG(CFG_CALLSIGN, nam, def, descr, NULL)
#define APRS_SYM(nam, def, descr)    MISC_CFG(CFG_APRSYM, nam, ('/'<<8)|(def), descr, NULL)

/* Most of these tables have magic ordering */

static byte
	*tab_personality[] = {
	     "Voice", "Tracker", "KISS", "Digipeater", "Scanner", NULL },

	*tab_tx_power[]    = { "5W", "1W", "200mW", "50mW", NULL },

	*tab_gps[]         = { "generic", "Garmin",   "Magellan",  "Aisin",
	                       "SiRF",    "TripMate", "EarthMate", "Zodiac",
	                       "SeaTalk", "Oncore",   "TSIP", NULL },

	*tab_lcd_type[]    = { "none", "ext",
	                       "44780A00", "44780A02", "LM1xxx",
	                       "KS0073", "KS0073ser",
	                       NULL },
	*tab_lcd_size[]    = { "none",
	                       "1x16", "2x16", "4x16",
	                       "1x20", "2x20", "4x20",
	                       "2x24", "2x40", "1x8",
	                       NULL },

	*tab_app_port[]    = { "1", "2", "auto", NULL },

	*tab_mic_e_ssid[]  = {
	     "none",       "wide-1",     "wide-2",    "wide-3",
	     "wide-4",     "wide-5",     "wide-6",    "wide-7",
	     "north",      "south",      "east",      "west",
	     "north+wide", "south+wide", "east+wide", "west+wide", NULL },
	*tab_mic_e_msg[]   = {
	     "off-duty",  "en-route", "in-service", "returning",
	     "committed", "special",  "priority",   "emergency",
	     "0", "1", "2", "3", "4", "5", "6", NULL },
	*tab_ptt_origin [] = { "DTR2", "MISO", "none", NULL },
	*tab_manipulator[] = { "none", "*", "DTR2", NULL },
#if 0
	*tab_chatboard  [] = { "none", "Ericsson", "Aplicom", "4800", "1200", NULL },
#endif
	*tab_ptt_packet [] = { "off", "id", "MIC-E", NULL },
	*tab_mytype     [] = { "normal", "object", "item", NULL },
	*tab_target_type[] = { "none", "object", "item", NULL },
	*tab_rn3function[] = { "none", "windmeter", "keypad", NULL },
	*tab_d9function [] = { "none", "onewire", "spi", NULL },
	*tab_tracker_digi[] = { "none", "relay", "wide", NULL },
	*tab_wide_is_trace[] = { "off", "on", "never", NULL },
	*tab_sensors    [] = { "none", "some", NULL },
	*tab_nmea_regen [] = { "off", "GPRMC", "custom", NULL };


struct cfgparm
cfg_parameters[] = {

	/* "rational" parameters */

#define GROUP ~0

	MISC_STR(profile_tag,        0, "name for these parameters"),
	MISC_TAB(personality, tab_personality, NULL),

	MISC_WORD(ttybaud,           0, "0: 19200 or any personality specific default"),
	MISC_TAB(app_port, tab_app_port, "gps or kiss attached to serial 1 or 2"),

	MISC_FREQ(freq,              0, "rx frequency, tx too if tx_freq=0"),
	MISC_FREQ(tx_freq,           0, "0=simplex, see 'freq'"),
	MISC_TAB(tx_power, tab_tx_power, "transmitter power"),

	CALL_SIGN(mycall,            0, "callsign and ssid, like OHnABC-n"),

	MISC_WORD(pll_delay,       100, "msecs to wait for PLL lock"),
	MISC_WORD(pwr_delay,       100, "msecs to wait for power to rise"),
	MISC_WORD(data_delay,      100, "msecs to wait before sending afsk"),
	MISC_WORD(squelch,         100, "squelch open/close level. see RSSI in 'stat'"),
	MISC_BOOL(use_busy,      FALSE, "BUSY input for dcd and squelch. not RSSI"),
	MISC_BOOL(use_softdcd,   FALSE, "software hack for dcd. not BUSY or RSSI"),

	MISC_BYTE(persistence,      64, "0 polite, 255 pig"),
	MISC_WORD(slottime,        100, "msec. channel access timing"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_VOICE) | (1 << PERSONALITY_SCANNER)

	MISC_WORD(ctcss,             0, "deciHz, like 1188 = 118.8. 0=off"),

	MISC_BOOL(autoscan,      FALSE, "voice p. scans channels when idle"),
	MISC_WORD(idle_time,        30, "seconds from ptt/squelch to autoscan"),
	MISC_WORD(scan_tail,         5, "seconds to linger before resuming scan"),
	MISC_BOOL(autobeep,       TRUE, "automatic 1750Hz burst if duplex-voice"),
	MISC_TAB(ptt_packet, tab_ptt_packet, "packet sent after voice ptt"),

	MISC_WORD(squelch_delay,   100, "msec of opening delay"),
	MISC_WORD(squelch_tail,    100, "msec of hang delay"),
	MISC_WORD(squelch_bilevel, 200, "no hang delay if rssi was over this"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_TRACKER)

	APRS_SYM(mysymbol,         '>', "2 characters or name. try help symbols"),

	MISC_WORD(track_distance, 1852, "meters travelled between reports. 0=disable"),
	MISC_WORD(track_interval, 1801, "seconds between reports. 0=disable"),
	MISC_WORD(track_limiter,    30, "seconds between reports, at minimum"),
	MISC_WORD(track_turnslope,3600, "km" STR_DEGREE "/h factor of CornerPegging. 0=disable"),
	MISC_WORD(track_highg,      40, "sideways acceleration in turn. 0=disable"),
	MISC_WORD(track_lowg,       10, "sideways acceleration after turn"),
	MISC_WORD(track_vertspeed,   0, "m/s descent threshold"),
	MISC_STR(digipath,           0, "normal tracker digipath. blank separated. see also aprs_dst"),
	MISC_STR(longpath,           0, "far reaching tracker digipath. blank separated"),
	MISC_WORD(long_area,     10000, "meters between longpath reports. 0=disable"),
	MISC_WORD(long_time,      3600, "seconds between longpath reports. 0=disable"),
	MISC_BOOL(use_compression, FALSE, "base91 compression when possible"),
	MISC_BOOL(use_mic_e,     FALSE, "send MIC-E formatted report"),
	MISC_TAB(gps,          tab_gps, "type of gps used. use generic for Garmin, Magellan, *mate or Sony IPS/ETAK. SiRF just reverts to NMEA (backchannel required)"),
	MISC_STR(gps_lat,            0, "fixed latitude. format 8959.99,N"),
	MISC_STR(gps_lon,            0, "fixed longitude. format 17959.99,E"),
	MISC_BOOL(waypoints,     FALSE, "reports to gps wpts"),
	MISC_STR(waypoint_tidy,      0, "blank separated prefixes peeled from wpt names. -A..Ea..e charset -F hex_ssid -4..9[-] maxlen"),


	/* obscure parameters */


#undef  GROUP
#define GROUP ~0

	MISC_FREQ(rx_if_offset,  21400, "normally 21400/2m, 44900/UHF"),
	MISC_BOOL(tx_lockout,    FALSE, "+12v in RTS1 overrides lockout"),
	MISC_WORD(txlimit,         300, "bytes (approx). limit a single keydown"),
	MISC_WORD(lobatt,            0, "engine monitor. wire +VB/3 to AN7. see 'stat'"),
	MISC_WORD(ttylines,         24, "pause long listings. 0=unlimited"),
	MISC_TAB(ptt_origin, tab_ptt_origin, "MISO needs +5VDD pullup"),

	CALL_SIGN(myalias,           0, "alias for digipeater, like RELAY. ssid usable"),
	CALL_SIGN(myalias2,          0, "another alias for me"),
	CALL_SIGN(mydomain,          0, "kind of admin alias, for remote cfg. ssid usable. also 'state' for wide-digi"),
	CALL_SIGN(contact,           0, "if unattended, who is to blame"),
	MISC_STR(rfpasswd,           0, "password for remote cfg"),
	MISC_STR(auth_key,           0, "secret key for remote authentication"),
	MISC_STR(goodfellas,         0, "can remote cfg without passwd/auth. no ssids"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_VOICE) | (1 << PERSONALITY_SCANNER)

	MISC_WORD(rssi_1led,       100, "signal strength to leds"),
	MISC_WORD(rssi_2led,       200, "signal strength to leds"),
	MISC_WORD(rssi_3led,       300, "signal strength to leds"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_KISS)

	MISC_WORD(kiss_trick,        0, "'token ring'. 0 disable. 1-15 sets also portnum"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_TRACKER)

	MISC_TAB(mic_e_ssid, tab_mic_e_ssid, "MIC-E path"),
	MISC_TAB(mic_e_msg,  tab_mic_e_msg,  NULL),
	MISC_STR(mic_e_telemetry, 0, "2 or 5 chars, like telemetry_format"),

	CALL_SIGN(aprs_dst,          0, "destination of aprs reports, default APZMDR"),
	CALL_SIGN(altnet,            0, "required destination in incoming packets. * and ? wildcards. default=*"),
	MISC_STR(bullgroups,         0, "bulletin groups, blank separated"),

	MISC_STR(event_packet,       0, "TAPR-format. sent when RTS2 changes or from lcd menu"),
	MISC_TAB(nmea_regen, tab_nmea_regen, "regenerate some gps info back to asy"),
	MISC_BOOL(send_altitude, FALSE, "report altitude if possible"),

	MISC_TAB(mytype,    tab_mytype, "what kind of animal I am. see myname"),
	MISC_STR(myname,             0, "object/item name. A-Z 0-9 only suggested"),

	MISC_TAB(target_type, tab_target_type, "is the target object or item ? none=disable target report"),
	MISC_STR(target_name,        0, "object/item name of GPS GoTo. each * replaced by digit from unique number. default=wpt_name"),
	APRS_SYM(target_symbol,    'c', "2 characters or name. try help symbols"),
	MISC_BOOL(target_comment, FALSE, "show active Goto in report"),

	MISC_STR(data_extension,     0, "PHGxxxx and others"),
	MISC_STR(long_comment,       0, "appended to longpath reports"),
	MISC_STR(short_comment,      0, "appended to normal reports"),

	MISC_STR(telemetry_format,   0, "telemetry mapping. 5+8+N chars. no default"),
	MISC_STR(telemetry_parm,     0, "see telemetry specification"),
	MISC_STR(telemetry_unit,     0, "see telemetry specification"),
	MISC_STR(telemetry_eqns,     0, "see telemetry specification"),
	MISC_STR(telemetry_bits,     0, "see telemetry specification"),

	MISC_BOOL(faith_in_pll,  FALSE, "ignore UNLOCK. AN5 generic A/D"),
	MISC_WORD(battscale,       150, "scale A/D to deciV. see 'stat'"),
	MISC_WORD(rainscale,       100, "scale pulses to inches"),
	MISC_WORD(anemoscale,     2237, "scale decipulse/msec to mph"),
	MISC_WORD(vaneoffset,        0, "degrees. north-offset of wind vane"),
	MISC_BOOL(wx_dump,       FALSE, "weather data to asy"),
	MISC_TAB(sensors,  tab_sensors, "any ?"),

	MISC_TAB(rn3_function, tab_rn3function, NULL),
	MISC_TAB(d9_function,  tab_d9function, NULL),

	MISC_TAB(lcd,          tab_lcd_type, NULL),
	MISC_TAB(lcd_size,     tab_lcd_size, NULL),
	MISC_TAB(manipulator,  tab_manipulator, NULL),
#if 0
	MISC_TAB(chatboard,    tab_chatboard, NULL),

	MISC_BOOL(dx_watch,      FALSE, "appended to longpath reports"),
	MISC_BOOL(channel_watch, FALSE, "appended to longpath reports"),
#endif

	MISC_TAB(tracker_digi, tab_tracker_digi, "hesitant RELAY or normal digi. myalias RELAY suggested"),
	MISC_WORD(relay_viscosity,  10, "seconds. wait other RELAY to act first"),
	MISC_WORD(dupe_age,         30, "seconds. duplicate packets not digipeated"),
	MISC_WORD(radio_range,      20, "kilometers. in stationary compressed reports, and for digiwatch"),
	MISC_WORD(waypoint_area,     0, "kilometers. distant reports not to gps"),
	MISC_WORD(digi_area,        10, "kilometers. distant reports not digipeated"),
	MISC_WORD(cell_area,         0, "kilometers. unexpectedly heard packets not digipeated"),
	MISC_TAB(wide_is_trace, tab_wide_is_trace, "insert instead of overwriting slots when digipeating. message packets are traced, unless 'never'"),
	MISC_WORD(maxdigi,           0, "allowed length of digipath"),

#undef  GROUP
};

#undef PARM_DESCR

#endif /* > 1 */
#endif /* > 0 */

